#    Decomposing graphs into edges and triangles
#    
#    Daniel Kral  Bernard Lidicky  Taisa L. Martins  Yanitsa Pehova
#
# This will perform rounding of the semidefinite program.
#
#

zerovectors = [[[1, 0, 3, 1, 0, 3, 0]]]
optimal_value = -42

load("rounding_exact.py")
p = FAProblem("SDP_n7_UB_F_edges2__objective.txt.dat-s")


#p.perform_rounding(optimal_value)
#print 
# This is rounding with forcing one zerovector.
# Result of this is in the paper
p.perform_rounding(optimal_value,zerovectors)

print  "Eigenvalues of solution:"
print  p.solutionRoundedM[0].eigenvalues()
print  "Test if [1, 0, 3, 1, 0, 3, 0]*solution is zero - i.e. zero eigenvector"
print  matrix(zerovectors[0][0])*p.solutionRoundedM[0]
print  "Solution multiplied by 6000000000:"
print  p.solutionRoundedM[0]*6000000000
print  "Note that in paper, one needs to write 12*10^9 instead of  6*10^9 since"
print  "we are solving program, where objective function is twice as large in order"
print  "to get integer coefficients"

#newp=p.change_base(zerovectors)

# This rounding creates a projection and round that afterwards.
'''
write_problem_file('altered.dat-s',newp)

print "Solving altered.dat-s using CSDP"
#print subprocess.Popen("~/bin/csdp altered.dat-s altered.dat-s.result",shell=True,stdout=subprocess.PIPE).communicate()[0]
print subprocess.Popen("csdp altered.dat-s altered.dat-s.result",shell=True,stdout=subprocess.PIPE).communicate()[0]
print "If solution is too different from",optimal_value,"then you have a bad luck :-("


pa = FAProblem("altered.dat-s")
pa.perform_rounding(optimal_value)
'''

