#!/bin/bash
#    Decomposing graphs into edges and triangles
#    
#    Daniel Kral  Bernard Lidicky  Taisa L. Martins  Yanitsa Pehova
#

# Create the objective function on 7 vertices
echo "Generating objective function"
sage generate_objective.sage > F_edges2__objective.txt

# Compile the program generating input for CSDP
make
# If runnig on Linux, one needs different target for make.
#make gcc

# Create the semidefinite program
# It also runs csdp automatically when the program is
# generated
./a.out -n 7 -ub

# Perform rounding of the solutoin
sage round.sage

# Check the solution we present in the paper
sage check_M.sage
